#include <amxmodx>
#include <engine>
#include <zombieplague>

#define TASK_BARTIME 1543874

new g_medicgun
new g_hasmedicgun[33]
new g_iCurrentWeapon[33]
new gmsgBarTime
new g_GMsgFade
new g_mediccost

new const medicgun_viewmodel[] = "models/v_bloodntears_antidotegun.mdl";


public plugin_init()
{
	register_plugin("Medic Gun", "1.0", "PsYChOPaTiQuE");
	register_event("CurWeapon", "event_CurWeapon", "b", "1=1");
	register_event("Damage", "event_Damage", "b", "2>0");
	register_event("HLTV","event_new_round", "a","1=0", "2=0");
	g_medicgun = zp_register_extra_item("Medic gun" ,g_mediccost , ZP_TEAM_HUMAN);
	gmsgBarTime = get_user_msgid("BarTime");
	g_GMsgFade = get_user_msgid("ScreenFade");
	g_mediccost = register_cvar("zp_medic_cost", "25");
}

public plugin_precache()
{ 
	precache_model(medicgun_viewmodel)
}

public zp_extra_item_selected(player, itemid)
{
	if ( itemid == g_medicgun )
	{
		g_hasmedicgun[player] = 1
		engclient_cmd( player, "weapon_knife" );
		client_print(player, print_chat,"[ZP] You have Medic Gun! Take your knife!");
	}
}

public event_CurWeapon(id)
{
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
		
	g_iCurrentWeapon[id] = read_data(2)
	
	if(zp_get_user_zombie(id) || zp_get_user_survivor(id))
		return PLUGIN_CONTINUE
		
	if(!g_hasmedicgun[id] || g_iCurrentWeapon[id] != CSW_KNIFE) 
		return PLUGIN_CONTINUE
		
	entity_set_string(id, EV_SZ_viewmodel, medicgun_viewmodel)
		
	return PLUGIN_CONTINUE
}

public event_Damage(id) 
{
	if(!is_user_alive(id) || is_user_bot(id)) 
		return PLUGIN_CONTINUE;

	new iWeapID, attacker = get_user_attacker(id, iWeapID);

	if(!is_user_connected(attacker))
		return PLUGIN_CONTINUE;

	if(!is_user_connected(id))
		return PLUGIN_CONTINUE;


	if(!g_hasmedicgun[attacker])
		return PLUGIN_CONTINUE;


	if(iWeapID == CSW_KNIFE) 
	{
		message_begin(MSG_ONE_UNRELIABLE, gmsgBarTime, _, id)
		write_short(3)
		message_end()
		set_task(3.0, "decontamine", id + TASK_BARTIME)
		client_print(id, print_chat,"[ZP] You will be a zombie in 3s !");
		set_task(0.0, "ecran_vert", attacker);
		client_print(attacker, print_chat,"[ZP] The zombie will become a human in 3s !");
	}

	return PLUGIN_CONTINUE;
}

public decontamine(id)
{
	id -= TASK_BARTIME
	zp_disinfect_user(id)
	set_task(0.0, "ecran_vert", id)
}

public ecran_vert(id)
{
	message_begin(MSG_ONE_UNRELIABLE, g_GMsgFade , {0,0,0}, id);
	write_short(1<<10);
	write_short(1<<10);
	write_short(0x0000);
	write_byte(0);
	write_byte(255);
	write_byte(0);
	write_byte(75);
	message_end();
}

public event_new_round()
{
	for(new i = 0; i < 32; i++)
	{
		g_hasmedicgun[i] = 0
	}

}
